// AtlDlg.h : Declaration of the CAtlDlg

#ifndef __ATLDLG_H_
#define __ATLDLG_H_

#include "resource.h"       // C V{
#include "CComDlgCtrl.h"
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CAtlDlg
class ATL_NO_VTABLE CAtlDlg :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IAtlDlg, &IID_IAtlDlg, &LIBID_HOWTOATLDLGLib>,
	//public CComControl<CAtlDlg>,	// 
	public CComDlgCtrl<CAtlDlg>,	// ɒu܂B
	public IPersistStreamInitImpl<CAtlDlg>,
	public IOleControlImpl<CAtlDlg>,
	public IOleObjectImpl<CAtlDlg>,
	public IOleInPlaceActiveObjectImpl<CAtlDlg>,
	public IViewObjectExImpl<CAtlDlg>,
	public IOleInPlaceObjectWindowlessImpl<CAtlDlg>,
	public IPersistStorageImpl<CAtlDlg>,
	public ISpecifyPropertyPagesImpl<CAtlDlg>,
	public IQuickActivateImpl<CAtlDlg>,
	public IDataObjectImpl<CAtlDlg>,
	public IProvideClassInfo2Impl<&CLSID_AtlDlg, NULL, &LIBID_HOWTOATLDLGLib>,
	public CComCoClass<CAtlDlg, &CLSID_AtlDlg>
{
public:
	enum { IDD = IDD_FORMVIEW };

	CAtlDlg()
	{
		m_bWindowOnly = TRUE;	// ǉ܂B
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLDLG)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAtlDlg)
	COM_INTERFACE_ENTRY(IAtlDlg)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CAtlDlg)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CAtlDlg)
	//CHAIN_MSG_MAP(CComControl<CAtlDlg>)	// 
	CHAIN_MSG_MAP(CComDlgCtrl<CAtlDlg>)		// ɒu܂B
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IAtlDlg
public:
/* OnDraw() 폜܂B
 *	HRESULT OnDraw(ATL_DRAWINFO& di)
 *	{
 *		RECT& rc = *(RECT*)di.prcBounds;
 *		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
 *
 *		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
 *		LPCTSTR pszText = _T("ATL 3.0 : AtlDlg");
 *		TextOut(di.hdcDraw,
 *			(rc.left + rc.right) / 2,
 *			(rc.top + rc.bottom) / 2,
 *			pszText,
 *			lstrlen(pszText));
 *
 *		return S_OK;
 *	}
 */
	STDMETHOD(TranslateAccelerator)(MSG *pMsg) {

		if (pMsg->message == WM_KEYDOWN) {
			switch (pMsg->wParam) {
			case VK_TAB:
			case VK_HOME:
			case VK_END:
			case VK_PRIOR:
			case VK_NEXT:
			case VK_UP:
			case VK_DOWN:
			case VK_LEFT:
			case VK_RIGHT:
				// _CAOvV[WɏB
				BOOL bRC = IsDialogMessage(pMsg);
				if (bRC) {
					return S_OK;
				}
				break;
			}
		}

		return S_FALSE;
	}

	// EBU[hgāAǉnhłB
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// MFC gꍇAK؂ȃW[Ԃɐ؂ւĂ
		// Kv܂B
		AFX_MANAGE_STATE(AfxGetStaticModuleState());
		//AfxMessageBox(_T("OnInitDialog"));
		return 0;
	}
};

#endif //__ATLDLG_H_
